
 Const NumberFont3x5 : Array[0..9,1..5,1..3] of Byte =
  (({0}
    (09,09,09),
    (09,00,09),
    (09,00,09),
    (09,00,09),
    (09,09,09)
   ),
   ({1}
    (00,09,00),
    (09,09,00),
    (00,09,00),
    (00,09,00),
    (00,09,00)
   ),
   ({2}
    (09,09,09),
    (00,00,09),
    (09,09,09),
    (09,00,00),
    (09,09,09)
   ),
   ({3}
    (09,09,09),
    (00,00,09),
    (00,09,09),
    (00,00,09),
    (09,09,09)
   ),
   ({4}
    (09,00,09),
    (09,00,09),
    (09,09,09),
    (00,00,09),
    (00,00,09)
   ),
   ({5}
    (09,09,09),
    (09,00,00),
    (09,09,09),
    (00,00,09),
    (09,09,09)
   ),
   ({6}
    (09,09,09),
    (09,00,00),
    (09,09,09),
    (09,00,09),
    (09,09,09)
   ),
   ({7}
    (09,09,09),
    (00,00,09),
    (00,00,09),
    (00,00,09),
    (00,00,09)
   ),
   ({8}
    (09,09,09),
    (09,00,09),
    (09,09,09),
    (09,00,09),
    (09,09,09)
   ),
   ({9}
    (09,09,09),
    (09,00,09),
    (09,09,09),
    (00,00,09),
    (09,09,09)
   ));


 Type

 String7 = String[7];

 Type TLittleNumbers = Object
                       {--------------------------}
                       Number : Array[1..20] of Record
                                 X,Y    : Integer;
                                 Frames : Word;
                                 Active : Boolean;
                                 Value  : String7;
                                End;
                       {--------------------------}
                        Procedure Create(_X,_Y : Integer; _Frames : Word; _Value : String7);
                        Procedure Draw;
                       End;

 Var LittleNumbers : TLittleNumbers;

 Procedure TLittleNumbers.Create;
 Var Index : Byte;
 Begin
   For Index := 1 To 20 Do If Not Number[Index].Active Then
   With Number[Index] Do Begin
     X := _X;
     Y := _Y;
     Frames := _Frames;
     Active :=  True;
     Value  := _Value;
     Break;
   End;
 End;

 Procedure DrawNumber(_X,_Y : Integer; _Number, C : Byte; TransParent : Boolean);
 Var Y, X : Integer;
     Calc : Byte;
 Begin
  For X := _X To _X + 2 Do Begin
    Calc := 1 SHL (X AND 3);
    Asm MOV DX, $03C5; MOV AL, CALC; OUT DX, AL End;
    For Y := _Y To _Y + 4 Do Begin
      If (NumberFont3x5[_Number,Y - _Y+1,X - _X + 1] <> 0) Then
      Mem[$A000:YOfs[Y]+(X Shr 2)+Page] := C Else IF Not TransParent Then
       Mem[$A000:YOfs[Y]+(X Shr 2)+Page] := 0
    End;
  End;
 End;

 Procedure DrawString(_X,_Y : Integer; Value : String; C : Byte; TransParent : Boolean);
 Var Index2 : Byte;
 Begin
  For Index2 := 1 To Byte(Value[0]) Do
   DrawNumber(_X+(Index2*4),_Y,Ord(Value[Index2])-48, C, TransParent);
 End;

 Procedure TLittleNumbers.Draw;
 Var Index : Byte;
 Begin
   For Index := 1 To 20 Do If Number[Index].Active Then
   With Number[Index] Do Begin
     If (Y < 0) or (Y > 260) Then Active := False;
     Dec(Y); Dec(Frames);
     If Frames = 0 Then Active := False;
      DrawStrinG(X,Y,Value, 16+(Frames Shr 1), True);
   End;
 End;
