Program Space;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Uses VGAMODEX, GAMEKEY, TIMER, FADE, CRT, PUSHPOPW;

 Var PowerUpje : TSprite; Naam : String;
     Kills : Integer;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 procedure DWrite(X,Y : Integer; attr : Byte ; Str : String); Assembler;
 (* DWrite - Direct Write, 0 BASED!                                        *)
 Asm
  push ds              (*                                                  *)
  mov bx,y             (*                                                  *)
  shl bx,1             (*                                                  *)
  mov ax,bx            (*                                                  *)
  shl bx,2             (*                                                  *)
  add ax,bx            (*                                                  *)
  add ax,$B800         (*                                                  *)
  mov es,ax            (*                                                  *)
  mov di,x             (*                                                  *)
  shl di,1             (*                                                  *)
  lds si,str           (*                                                  *)
  mov cl,byte ptr [si] (*                                                  *)
  cmp cl, 0
  je @3
  inc si               (*                                                  *)
  mov ah,attr          (*                                                  *)
  @1:                  (*                                                  *)
  mov al,byte ptr [si] (*                                                  *)
  mov word ptr es:[di],ax
  inc si               (*                                                  *)
  add di,2             (*                                                  *)
  dec cl               (*                                                  *)
  jnz @1               (*                                                  *)
 @3:
  pop ds               (*                                                  *)
 End;

  Function CopyChar(Const C : Char; Const Times : Byte): String; Assembler;
  Asm
   Push Ds                    (* Ok                                        *)
   Les Di, @Result            (* Ok                                        *)
   Lodsb                      (* Dl := Length(Source);                     *)
   Mov Al, Times              (* Length(Result) := Size                    *)
   Stosb                      (*                                           *)
   Mov Al, C                  (* Al := #48;                                *)
   Mov Bl, Times              (* Bl := Size - Length(Source);              *)
   Xor Bh, Bh                 (* Bh := 0                                   *)
  @@1:                       (* Repeat                                    *)
   Stosb                     (*                                           *)
   Inc Bh                    (*                                           *)
   Cmp Bh, Bl                (*                                           *)
  Jb @@1                     (* While Bh < Bl;                            *)
  Pop Ds
 End;

 Function ZeroSize(Const Source : String; Size : Byte): String;
 Begin
  If Length(Source) < Size Then ZeroSize := CopyChar('0',Size-Length(Source))+Source Else
  ZeroSize := Source;
 End;

 Function Size(S : String; Sizze : Byte): String;
 Var Index : Word;
 Begin
   If Byte(S[0]) > Sizze then S[0] := Char(Sizze);
   Size := S + CopyChar(' ', Sizze-Byte(S[0]));
 End;

  Function Int2Str(I: Longint): String;
  (*                                                                     *)
  Var
   S: string[11];
  Begin
   Str(I, S);
   Int2Str := S;
  End;

 Procedure StuurNaar(Var Track : Byte; PosX, PosY : Integer; Var X, Y, XVel, YVel : Real; Axrate, MaxVel : Real);
 Var A,B : Integer;
 Begin
  X := X + XVel;
  Y := Y + YVel;
  If PosX > X Then If XVel < MaxVel Then XVel := XVel + Axrate;
  If PosX < X Then If XVel > -MaxVel Then XVel := XVel - Axrate;

  If PosY > Y Then If YVel < MaxVel Then YVel := YVel + Axrate;
  If PosY < Y Then If YVel > -MaxVel Then YVel := YVel - Axrate;
  A := Round(PosX - X); If A < 0 Then A := -A;
  B := Round(PosY - Y); If B < 0 THen B := -B;
  IF A+B < 50 Then Inc(Track);
{  Track := 2;}
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Const MaxEvasives = 6;
       MaxShips    = 3;
       MaxBonus    = 4;

 Var TrackX, TrackY : Integer;

 {$I TLittle}
 {$I TBONUS}
 {$I TSTARS}
 {$I TBULL}
 {$I TLIVE}
 {$I TEXPL}
 {$I TALIEN}
 {$I TSHIP}
 {$I THIGH}
 {$I TSCENARY}

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Var Addr6845      : Word Absolute $40:$63;

 Procedure Wait4Retrace; Assembler;
 (*                                                                        *)
 Asm
  Mov ax,seg addr6845  (*                                                  *)
  Mov es,ax            (*                                                  *)
  Mov dx,es:[addr6845] (*                                                  *)
  Add dx,6             (*                                                  *)
  @Loop:               (*                                                  *)
  in al,dx             (*                                                  *)
  test al,8            (*                                                  *)
  jz @Loop             (*                                                  *)
 End;

 Procedure Evasive(Action, Soort : Byte);
 Var A : Word;
 Begin
  A := Aliens.Place(Soort);
  With Aliens.Exp[A] Do Begin
  Case Action Of
   1 : Begin
         Poss[1].X := 160;
         Poss[1].Y := 300;
         Poss[2].X := 160;
         Poss[2].Y := 50;
         Poss[3].X := 600;
         Poss[3].Y := 100;
         Poss[4].X := -1;
         Poss[4].Y := 0;
       End;
   2 : Begin
         Poss[1].X := 60;
         Poss[1].Y := 300;
         Poss[2].X := 60;
         Poss[2].Y := 100;
         Poss[3].X := 600;
         Poss[3].Y := 100;
         Poss[4].X := -1;
         Poss[4].Y := 0;
       End;
   3 : Begin
         Poss[1].X := -50;
         Poss[1].Y := 150;
         Poss[2].X := 160;
         Poss[2].Y := 100;
         Poss[3].X := 400;
         Poss[3].Y := 150;
         Poss[4].X := -1;
         Poss[4].Y := 0;
       End;
   4 : Begin
         Poss[1].X := 400;
         Poss[1].Y := 150;
         Poss[2].X := 160;
         Poss[2].Y := 100;
         Poss[3].X := -30;
         Poss[3].Y := -30;
         Poss[4].X := -1;
         Poss[4].Y := 0;
       End;
   5 : Begin
         Poss[1].X := 200;
         Poss[1].Y := 400;
         Poss[2].X := 200;
         Poss[2].Y := 300;
         Poss[3].X := 100;
         Poss[3].Y := -30;
         Poss[4].X := -1;
         Poss[4].Y := 0;
       End;
   6 : Begin
         Poss[1].X := Random(200);
         Poss[1].Y := 300;
         Poss[2].X := Random(500)-250;
         Poss[2].Y := Random(500)-250;
         Poss[3].X := Random(500)-250;
         Poss[3].Y := Random(500)-250;
         Poss[4].X := -1;
         Poss[4].Y := 0;
       End;
  End;
  Case Soort of
     1 : Begin CannonX := 2; CannonY := 2; CannonType := 1; Score_ := 100; Tracking := False; End;
     2 : Begin CannonX := 2; CannonY := 2; CannonType := 2; Score_ := 250; Tracking := False; End;
     3 : Begin CannonX := 2; CannonY := 2; CannonType := 3; Score_ := 500; Tracking := True;  End;
  End;
  End;
  Aliens.SetStart(A);
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Var PPage : Byte;

 Procedure SwapPage;
 Begin
  PPage := 1 - PPage;
  SetVisualPage(1 - PPage);
  Wait4Retrace;
  SetDrawPage(PPage);
{  Repeat Until Port[$3DA] And 8 = 8; { Wait For Vertical retrace              }
  Fill(0);
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)


 Procedure Entrance;
 Var Index : Integer;
     X : Integer;
     Where : Word;
     Count2 : Byte;
 Procedure RotateWait;
 Begin
  With Scenary Do Begin
    S00.Current := 4+Where;
    Inc(Count2);
    If Count2 = 5 Then Begin
     Inc(Where);
     Count2 := 0;
    End;
    If Where = 3 Then Where := 0;
    S00.GotoXY(166,90);
    S00.Draw;
  End;
 End;
 Procedure DoFire(_X, _Y : Integer);
 Begin
  With MainShip Do Begin
    S00.Current := 7+Random(3);
    S00.GotoXY(_X,_Y-22);
    S00.Draw;
  End;
 End;
 Begin

  Where := 0; Count2 := 0;

  X := (Screen_Width Shr 1) - 14;

  For Index := -30 To 01+20 Do Begin
   Live.DrawAll;
   Stars.Draw;
   DoFire(X,Index);
   With MainShip Do Begin
   S00.Current := 4;
   S00.GotoXY(X, Index);
   S00.Draw;
   End;
   SwapPage;
  End;

  For Index := 02+20 To 08+20 Do Begin
   Live.DrawAll;
   Stars.Draw;
   With MainShip Do Begin
   S00.Current := 5;
   S00.GotoXY(X, Index);
   S00.Draw;
   End;
   SwapPage;
  End;

  For Index := 09+20 To 14+21 Do Begin
   Live.DrawAll;
   Stars.Draw;
   With MainShip Do Begin
   S00.Current := 6;
   S00.GotoXY(X, Index);
   S00.Draw;
   End;
   SwapPage;
  End;

  For Index := 0 To 100 Do Begin
   Live.DrawAll;
   Stars.Draw;
   With MainShip Do Begin
   S00.Current := 1;
   S00.GotoXY(X, 14+22);
   S00.Draw;
   End;
   RotateWait;
   SwapPage;
   If Keys[1] or Keys[32] Then Break;
  End;


 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 var DeadCount : LongInt;

 Procedure GameLoop;
 Var Index : Byte;
 Begin
  FadeGetOld;
  DeadCount := 0;
  PPage := 0; SetDrawPage(1); SetVisualPage(0);
  Entrance;
  While Not 1<>2 Do Begin
   Stars.Draw;
   Scenary.DrawAll;
   If Not Live.Dead Then
   With MainShip Do
   Case MainShip.PowerUp of
    1 : Begin
         PowerUpje.GotoXY(X-05,Y+08); PowerUpje.Current := 1; PowerUpje.Draw;
         PowerUpje.GotoXY(X+16,Y+08); PowerUpje.Current := 2; PowerUpje.Draw;
        End;
    2:  Begin
         PowerUpje.GotoXY(X-05-5,Y+08); PowerUpje.Current := 1; PowerUpje.Draw;
         PowerUpje.GotoXY(X-05,Y+08); PowerUpje.Current := 1; PowerUpje.Draw;
         PowerUpje.GotoXY(X+16,Y+08); PowerUpje.Current := 2; PowerUpje.Draw;
         PowerUpje.GotoXY(X+16+5,Y+08); PowerUpje.Current := 2; PowerUpje.Draw;
        End;
    3:  Begin
         PowerUpje.GotoXY(X-05-5-5,Y+08); PowerUpje.Current := 1; PowerUpje.Draw;
         PowerUpje.GotoXY(X-05-5,Y+08); PowerUpje.Current := 1; PowerUpje.Draw;
         PowerUpje.GotoXY(X-05,Y+08); PowerUpje.Current := 1; PowerUpje.Draw;
         PowerUpje.GotoXY(X+16,Y+08); PowerUpje.Current := 2; PowerUpje.Draw;
         PowerUpje.GotoXY(X+16+5,Y+08); PowerUpje.Current := 2; PowerUpje.Draw;
         PowerUpje.GotoXY(X+16+5+5,Y+08); PowerUpje.Current := 2; PowerUpje.Draw;
        End;
    4:  Begin
         PowerUpje.GotoXY(X-05-5-10,Y+08); PowerUpje.Current := 1; PowerUpje.Draw;
         PowerUpje.GotoXY(X-05-5,Y+08); PowerUpje.Current := 3; PowerUpje.Draw;
         PowerUpje.GotoXY(X-05,Y+08); PowerUpje.Current := 1; PowerUpje.Draw;
         PowerUpje.GotoXY(X+16,Y+08); PowerUpje.Current := 2; PowerUpje.Draw;
         PowerUpje.GotoXY(X+16+5,Y+08); PowerUpje.Current := 3; PowerUpje.Draw;
         PowerUpje.GotoXY(X+16+5+10,Y+08); PowerUpje.Current := 2; PowerUpje.Draw;
        End;
   End;
   Live.DrawAll;
   Bonus.DrawAll;
   MainShip.Draw;
   Explosions.DrawAll;
   MainShip.LetUserOperate;
   Bullets.DrawAll;
   If Random(5000) = 1 Then Scenary.Shoot(Random(Screen_Width)-10,271,1);
   If Random(100) = 1 Then Evasive(Random(MaxEvasives)+1,Random(maxShips)+1);
   If Random(750) = 1 Then Bonus.Create(Random(Screen_Width-100)+50, 300, 0,-1,1);
   If Random(750) = 1 Then Bonus.Create(Random(Screen_Width-100)+50, 300, 0,-1,5);
   If Random(750) = 1 Then Bonus.Create(Random(Screen_Width-100)+50, 300, 0,-1,9);
{  For Index := 1 To 25 Do
   If Bullets.Bul[Index].ACtive then If Bullets.Bul[Index].Soort = 8 Then With Bullets.Bul[Index] DO If (MainShip.Count Mod 8)
    = 0 THen
   Explosions.Place(X,Y,1);}
   Aliens.DrawAll;
   LittleNumbers.Draw;
   SwapPage;
   If Keys[1] and (live.over > 0) Then MainShip.Explode;
   If Live.Dead THen Begin
    Inc(DeadCount);
    IF DeadCount > 40 Then
    SetInten(64+40-DeadCount);
    if DeadCount = 62+40 Then Break;
   End;
  End;
{  }
  delay(100);
  While Keys[1] Do;
  SwapPage;
  HighScore.View;
  SwapPage;
  FadeIn (16);
  Repeat Until Keys[1];
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure GetName;
 Label Again;

 Begin
  Dwrite(0,0,$4F,Size('MD SPACEGAME, (C) 1997, Daan van Yperen',70)+'v0.5 Beta');
  Again:
  Dwrite(0,2,$07, 'Enter your name                              ');
  Dwrite(15,2,$03, ':');
  GotoXY(18,3);
  TextColor($F);
  REadLn(Naam);
  IF Naam = '' Then begin
   Dwrite(0,3,$0F, 'Without a name, i cannot add you to the highscore list! Try again.');
   Goto Again;
  End;
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure LoadImages;
 Begin
  MainShip.Load;
  Explosions.Load;
  Bullets.Load;
  HighScore.Load;
  Bonus.Load;
  Scenary.Load;
  Live.Load;
  Aliens.Load;
  PowerUpje.Load('SPPOWER.WAD',1);
  Stars.Spread; Capture_Keyboard; Fill(0); MainShip.PowerUp := 0;
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Begin

  Randomize;

  GetName;

  PushWindow;

  Modex(360,240);

  LoadImages;
  GameLoop;

  VideoMode($3);

  PopWindow;

 End.
